model BouncingBall 
  Real y;
  Real vy;
  parameter Real g=9.8;
  parameter Real m=1.0;
  parameter Real k=1.0;
equation 
  
  der(y) = vy;
  der(vy) = -g;
  when y < 0 then
    reinit(vy, -k*vy);
  end when;
  
end BouncingBall;
